<!--
 * @Descripttion:
 * @version:
 * @Author: kBank
 * @Date: 2022-10-24 15:45:01
-->
<template>
  <div class="page">
    <topBar v-if="topList.length > 0"
            :topList="topList"
            :moren="moren"></topBar>
    <div class="main">
      <div class="form_all">
        <el-form ref="select"
                 :model="select"
                 label-width="auto">
          <el-row :gutter="10">
            <el-col :span="4">
              <el-form-item :label="'会员编号'"
                            prop="memberCode">
                <el-input clearable
                          v-model="select.memberCode"
                          :placeholder="'请输入'"></el-input>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="统计时间">
                <el-date-picker v-model="creationTime"
                                @change="changeTime"
                                value-format="yyyy-MM-dd"
                                type="daterange"
                                :range-separator="'至'"
                                :start-placeholder="'开始日期'"
                                :end-placeholder="'结束日期'">
                </el-date-picker>
              </el-form-item>
            </el-col>
            <el-col :span="4">
              <el-button type="primary"
                         @click="getDataList"> {{ '搜索' }}</el-button>
              <el-button type=""
                         @click="reset"> {{ '重置' }}</el-button>
            </el-col>
          </el-row>
        </el-form>
      </div>
      <div class="maintop">
        <div class="mainbtn">
          <el-button size="small"
                     @click="handleExport"
                     v-hasButtons="['MemberAchieveExport']"
                     style="background-color: #ffad41"
                     class="thebtn1"> {{ '导出' }}</el-button>
        </div>
      </div>
      <div class="maintable">
        <el-table :data="tableData"
        v-loading="loading"
                  style="width: 100%"
                  :header-cell-style="{ background: '#EEEEEE' }"
                  :row-class-name="tableRowClassName"
                  @selection-change="handleSelectionChange">
          <el-table-column type="selection"
                           width="55"> </el-table-column>
          <el-table-column align="center"
                           prop="memberCode"
                           :label="'会员编号'">
          </el-table-column>
          <el-table-column align="center"
                           prop="memberName"
                           :label="'会员姓名'">
          </el-table-column>
          <el-table-column align="center"
                           prop="pushOrderAchieve"
                           label="推荐伞下新增业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="resettleAchieve"
                           label="安置伞下新増业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="leftResettleAchieve"
                           label="安置左区新增业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="rightResettleAchieve"
                           label="安置右区新增业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="registerAchieve"
                           label="报单新增业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="directAchieve"
                           label="直推业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="replyAchieve"
                           label="复购业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="tradeAchieve"
                           label="复购扣除业绩">
          </el-table-column>
          <el-table-column align="center"
                           prop="realIncomeTotal"
                           label="奖金收益">
          </el-table-column>
        </el-table>
      </div>
    </div>
    <pagination v-show="total>0"
                :total="total"
                :page.sync="queryParams.pageNum"
                :limit.sync="queryParams.pageSize"
                @pagination="getDataList" />
  </div>
</template>

<script>
import topBar from '@/components/topBar'
import * as api from '@/api/statistics.js'
import { getgradeRanglist } from '@/api/level'
import { getvertexValue } from '@/api/member'
export default {
  name: 'Bzpz',
  components: {
    topBar,
  },

  data() {
    return {
      creationTime: [],
      gradeRangList: [],
      vertexList: [],
      select: {},
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
      },
      total: 0,
      tableData: [],
      loading:false,
      moren: 'memberAchieve',
      topList: [
        {
          name: '会员业绩数据查询',
          path: 'memberAchieve',
        },
      ]
    }
  },
  mounted() {
    // 获取列表
    // this.getDataList()
    var s1 = this.getStartTime()
    var s2 = this.getEndTime()
    this.select.startDate = s1
    this.select.endDate = s2

    this.creationTime = [s1, s2]
    this.getData()
  },
  methods: {
    getStartTime() {
      let date = new Date()
      // console.error(date.getDate()==1?date.getMonth():date.getMonth() + 1)
      let year = date.getFullYear() // 得到当前年份
      let month = date.getDate() === 1 ? date.getMonth() : date.getMonth() + 1 // 得到当前月份（0-11月份，+1是当前月份）
      date.setDate(1) // 将当前时间的日期设置成第一天
      month = month >= 10 ? month : '0' + month // 补零
      let day = date.getDate() // 得到当前天数，实际是本月第一天，因为前面setDate(1) 设置过了
      day = day >= 10 ? day : '0' + day // 补零
      return year + '-' + month + '-' + day
    },
    getEndTime() {
      var date = new Date()
      var year = date.getFullYear() // 年
      let month = date.getDate() === 1 ? date.getMonth() : date.getMonth() + 1 // 得到当前月份（0-11月份，+1是当前月份）
      var day = date.getDate()
      let day1 = date.getDate()
      // 给一位数的数据前面加 “0”
      if (month >= 1 && month <= 9) {
        month = '0' + month
      }
      if (day >= 0 && day <= 9) {
        day = '0' + day
      }
      if (day1 == 1) {
        var date2 = new Date()
        var year2 = date2.getFullYear()
        var month2 = date2.getMonth()
        var dates = new Date(year2, month2, 0).getDate()
        day = dates
      }
      return year + '-' + month + '-' + day
    },
    getData() {
      getgradeRanglist().then((res) => {
        this.gradeRangList = res.data
      })
      getvertexValue().then((res) => {
        this.vertexList = res.data
      })
    },
    reset() {
      this.select = {}
      this.creationTime = []
    },
    changeTime(val) {
      this.select.startDate = val ? val[0] : ''
      this.select.endDate = val ? val[1] : ''
    },
    getDataList() {
      for (let key in this.select) {
        if (this.select[key] == '') {
          delete this.select[key]
        }
      }
      this.loading = true
      api
        .memberAchieve(Object.assign({}, this.queryParams, this.select))
        .then((res) => {
          this.tableData = res.rows
          this.total = res.total
          this.loading = false
        })
    },
    handleSelectionChange(val) {
      let a = val.map((item) => {
        return item.pkMember
      })
      let b = a.join(',')
      this.$set(this.select, 'pkMemberStr', b)
    },
    /** 导出按钮操作 */
    handleExport() {
      this.$confirm('是否确认导出所有数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      }).then((_) => {
        this.download(
          '/report/manager/member-awards/member-achieve-export',
          Object.assign({}, this.queryParams, this.select),
          `会员业绩数据查询${new Date().getTime()}.xlsx`
        )
      })
    },
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex % 2 == 1) {
        return 'warning-row'
      } else if (rowIndex % 2 == 0) {
        return 'success-row'
      }
      return ''
    },
  },
}
</script>
<style scoped lang="scss">
::v-deep .el-table .warning-row {
  background: #f9f9f9;
}

::v-deep .el-table .success-row {
  background: #ffffff;
}
::v-deep .el-table thead {
  color: #000000;
}
::v-deep .el-select {
  width: 100%;
}
.uploadIcon ::v-deep .el-upload--picture-card {
  display: none !important; /* 上传按钮隐藏 */
}
.page {
  padding: 20px;
  background: #f9f9f9;
  font-size: 14px;
  .main {
    background: #ffffff;
    border-radius: 8px;
    box-shadow: 0px 2px 20px 0px rgba(238, 238, 238, 0.5);
    .form_all {
      padding: 0px 20px 0 20px;
      // margin-bottom: 20px;
      background: #fff;
      border-radius: 8px;
    }
    .maintop {
      display: flex;
      padding: 0px 0px;
      justify-content: space-between;
      align-items: center;

      background: #f8f8f8;
      .mainbtn {
        .thebtn1 {
          background: #3181e5;
          color: #ffffff;
        }
        .thebtn2 {
          background: #ffad41;
          color: #ffffff;
        }
      }
      .maintitle {
        font-size: 10px;
        font-family: MicrosoftYaHei;
        color: #999999;
      }
    }
  }
  .tem {
    display: flex;
    align-items: center;
    justify-content: center;
    img {
      width: 28px;
      height: 20px;
      margin-right: 3px;
    }
  }
  .isRed {
    color: #ed1d25;
  }
  .isGreen {
    color: #1ab62b;
  }
  .bgImg {
    width: 48px;
    height: 48px;
  }
}
.openClose {
  text-align: right;
  margin-right: 10px;
  color: #3181e5;
}
.dizhi {
  ::v-deep .el-cascader {
    width: 100%;
  }
}
::v-deep .el-date-editor.el-input,
.el-date-editor.el-input__inner {
  width: auto;
}
</style>
